

#define XK_LATIN1
#define XK_GREEK
#include <X11/keysymdef.h>

#define SEMICOL_NDX 26

Bool DoMap (Display *dpy, XkbDescPtr xkb) 
{
  int
    ks,
    i= 0, 
    j = 0;

  for (i=xkb->min_key_code; i<xkb->max_key_code; i++) {
    ks = xkb->map->syms[xkb->map->key_sym_map[i].offset];

    switch (ks) {
    case XK_a:
      almap[j].kk = i;
      almap[j].lks = XK_a;
      almap[j].Lks = XK_A;
      almap[j].gks = XK_Greek_alpha;
      almap[j].Gks = XK_Greek_ALPHA;
      almap[j].gaks = XK_Greek_alphaaccent;
      almap[j].Gaks = XK_Greek_ALPHAaccent;
      j++;
      break;
    case XK_b:
      almap[j].kk = i;
      almap[j].lks = XK_b;
      almap[j].Lks = XK_B;
      almap[j].gks = XK_Greek_beta;
      almap[j].Gks = XK_Greek_BETA;
      almap[j].gaks = XK_Greek_beta;
      almap[j].Gaks = XK_Greek_BETA;
      j++;
      break;
    case XK_c:
      almap[j].kk = i;
      almap[j].lks = XK_c;
      almap[j].Lks = XK_C;
      almap[j].gks = XK_Greek_psi;
      almap[j].Gks = XK_Greek_PSI;
      almap[j].gaks = XK_Greek_psi;
      almap[j].Gaks = XK_Greek_PSI;
      j++;
      break;
    case XK_d:
      almap[j].kk = i;
      almap[j].lks = XK_d;
      almap[j].Lks = XK_D;
      almap[j].gks = XK_Greek_delta;
      almap[j].Gks = XK_Greek_DELTA;
      almap[j].gaks = XK_Greek_delta;
      almap[j].Gaks = XK_Greek_DELTA;
      j++;
      break;
    case XK_e:
      almap[j].kk = i;
      almap[j].lks = XK_e;
      almap[j].Lks = XK_E;
      almap[j].gks = XK_Greek_epsilon;
      almap[j].Gks = XK_Greek_EPSILON;
      almap[j].gaks = XK_Greek_epsilonaccent;
      almap[j].Gaks = XK_Greek_EPSILONaccent;
      j++;
      break;
    case XK_f:
      almap[j].kk = i;
      almap[j].lks = XK_f;
      almap[j].Lks = XK_F;
      almap[j].gks = XK_Greek_phi;
      almap[j].Gks = XK_Greek_PHI;
      almap[j].gaks = XK_Greek_phi;
      almap[j].Gaks = XK_Greek_PHI;
      j++;
      break;
    case XK_g:
      almap[j].kk = i;
      almap[j].lks = XK_g;
      almap[j].Lks = XK_G;
      almap[j].gks = XK_Greek_gamma;
      almap[j].Gks = XK_Greek_GAMMA;
      almap[j].gaks = XK_Greek_gamma;
      almap[j].Gaks = XK_Greek_GAMMA;
      j++;
      break;
    case XK_h:
      almap[j].kk = i;
      almap[j].lks = XK_h;
      almap[j].Lks = XK_H;
      almap[j].gks = XK_Greek_eta;
      almap[j].Gks = XK_Greek_ETA;
      almap[j].gaks = XK_Greek_etaaccent;
      almap[j].Gaks = XK_Greek_ETAaccent;
      j++;
      break;
    case XK_i:
      almap[j].kk = i;
      almap[j].lks = XK_i;
      almap[j].Lks = XK_I;
      almap[j].gks = XK_Greek_iota;
      almap[j].Gks = XK_Greek_IOTA;
      almap[j].gaks = XK_Greek_iotaaccent;
      almap[j].Gaks = XK_Greek_IOTAaccent;
      j++;
      break;
    case XK_j:
      almap[j].kk = i;
      almap[j].lks = XK_j;
      almap[j].Lks = XK_J;
      almap[j].gks = XK_Greek_xi;
      almap[j].Gks = XK_Greek_XI;
      almap[j].gaks = XK_Greek_xi;
      almap[j].gaks = XK_Greek_XI;
      j++;
      break;
    case XK_k:
      almap[j].kk = i;
      almap[j].lks = XK_k;
      almap[j].Lks = XK_K;
      almap[j].gks = XK_Greek_kappa;
      almap[j].Gks = XK_Greek_KAPPA;
      almap[j].gaks = XK_Greek_kappa;
      almap[j].Gaks = XK_Greek_KAPPA;
      j++;
      break;
    case XK_l:
      almap[j].kk = i;
      almap[j].lks = XK_l;
      almap[j].Lks = XK_L;
      almap[j].gks = XK_Greek_lambda;
      almap[j].Gks = XK_Greek_LAMBDA;
      almap[j].gaks = XK_Greek_lambda;
      almap[j].gaks = XK_Greek_LAMBDA;
      j++;
      break;
    case XK_m:
      almap[j].kk = i;
      almap[j].lks = XK_m;
      almap[j].Lks = XK_M;
      almap[j].gks = XK_Greek_mu;
      almap[j].Gks = XK_Greek_MU;
      almap[j].gaks = XK_Greek_mu;
      almap[j].Gaks = XK_Greek_MU;
      j++;
      break;
    case XK_n:
      almap[j].kk = i;
      almap[j].lks = XK_n;
      almap[j].Lks = XK_N;
      almap[j].gks = XK_Greek_nu;
      almap[j].Gks = XK_Greek_NU;
      almap[j].gaks = XK_Greek_nu;
      almap[j].gaks = XK_Greek_NU;
      j++;
      break;
    case XK_o:
      almap[j].kk = i;
      almap[j].lks = XK_o;
      almap[j].Lks = XK_O;
      almap[j].gks = XK_Greek_omicron;
      almap[j].Gks = XK_Greek_OMICRON;
      almap[j].gaks = XK_Greek_omicronaccent;
      almap[j].Gaks = XK_Greek_OMICRONaccent;
      j++;
      break;
    case XK_p:
      almap[j].kk = i;
      almap[j].lks = XK_p;
      almap[j].Lks = XK_P;
      almap[j].gks = XK_Greek_pi;
      almap[j].Gks = XK_Greek_PI;
      almap[j].gaks = XK_Greek_pi;
      almap[j].Gaks = XK_Greek_PI;
      j++;
      break;
    case XK_q:
      almap[j].kk = i;
      almap[j].lks = XK_q;
      almap[j].Lks = XK_Q;
      almap[j].gks = XK_semicolon;
      almap[j].Gks = XK_colon;
      almap[j].gaks = XK_semicolon;
      almap[j].Gaks = XK_colon;
      j++;
      break;
    case XK_r:
      almap[j].kk = i;
      almap[j].lks = XK_r;
      almap[j].Lks = XK_R;
      almap[j].gks = XK_Greek_rho;
      almap[j].Gks = XK_Greek_RHO;
      almap[j].gaks = XK_Greek_rho;
      almap[j].Gaks = XK_Greek_RHO;
      j++;
      break;
    case XK_s:
      almap[j].kk = i;
      almap[j].lks = XK_s;
      almap[j].Lks = XK_S;
      almap[j].gks = XK_Greek_sigma;
      almap[j].Gks = XK_Greek_SIGMA;
      almap[j].gaks = XK_Greek_sigma;
      almap[j].Gaks = XK_Greek_SIGMA;
      j++;
      break;
    case XK_t:
      almap[j].kk = i;
      almap[j].lks = XK_t;
      almap[j].Lks = XK_T;
      almap[j].gks = XK_Greek_tau;
      almap[j].Gks = XK_Greek_TAU;
      almap[j].gaks = XK_Greek_tau;
      almap[j].Gaks = XK_Greek_TAU;
      j++;
      break;
    case XK_u:
      almap[j].kk = i;
      almap[j].lks = XK_u;
      almap[j].Lks = XK_U;
      almap[j].gks = XK_Greek_theta;
      almap[j].Gks = XK_Greek_THETA;
      almap[j].gaks = XK_Greek_theta;
      almap[j].Gaks = XK_Greek_THETA;
      j++;
      break;
    case XK_v:
      almap[j].kk = i;
      almap[j].lks = XK_v;
      almap[j].Lks = XK_V;
      almap[j].gks = XK_Greek_omega;
      almap[j].Gks = XK_Greek_OMEGA;
      almap[j].gaks = XK_Greek_omegaaccent;
      almap[j].Gaks = XK_Greek_OMEGAaccent;
      j++;
      break;
    case XK_w:
      almap[j].kk = i;
      almap[j].lks = XK_w;
      almap[j].Lks = XK_W;
      almap[j].gks = XK_Greek_finalsmallsigma;
      almap[j].Gks = XK_Greek_SIGMA;
      almap[j].gaks = XK_Greek_finalsmallsigma;
      almap[j].Gaks = XK_Greek_SIGMA;
      j++;
      break;
    case XK_x:
      almap[j].kk = i;
      almap[j].lks = XK_x;
      almap[j].Lks = XK_X;
      almap[j].gks = XK_Greek_chi;
      almap[j].Gks = XK_Greek_CHI;
      almap[j].gaks = XK_Greek_chi;
      almap[j].Gaks = XK_Greek_CHI;
      j++;
      break;
    case XK_y:
      almap[j].kk = i;
      almap[j].lks = XK_y;
      almap[j].Lks = XK_Y;
      almap[j].gks = XK_Greek_upsilon;
      almap[j].Gks = XK_Greek_UPSILON;
      almap[j].gaks = XK_Greek_upsilonaccent;
      almap[j].Gaks = XK_Greek_UPSILONaccent;
      j++;
      break;
    case XK_z:
      almap[j].kk = i;
      almap[j].lks = XK_z;
      almap[j].Lks = XK_Z;
      almap[j].gks = XK_Greek_zeta;
      almap[j].Gks = XK_Greek_ZETA;
      almap[j].gaks = XK_Greek_zeta;
      almap[j].Gaks = XK_Greek_ZETA;
      j++;
      break;
    case XK_semicolon:
      almap[26].kk = i;
      almap[26].lks = XK_semicolon;
      almap[26].Lks = XK_colon;
      break;
    default:
      break;
    } /* switch. */
  } /* for. */

  if (j < 26) {
    printf("KeySyms found: %d\n",j);
    return(False);
  } else {
    return(True);
  }
}


	    
